
package com.sonicsw.esbx.ws;

import java.io.File;
import java.io.FileInputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Properties;

import javax.xml.namespace.QName;
import javax.xml.ws.Service;
import javax.xml.ws.WebEndpoint;
import javax.xml.ws.WebServiceClient;
import javax.xml.ws.WebServiceFeature;

import org.apache.cxf.endpoint.Server;
import org.apache.cxf.interceptor.LoggingInInterceptor;
import org.apache.cxf.interceptor.LoggingOutInterceptor;
import org.apache.cxf.jaxws.JaxWsServerFactoryBean;
 
/**
 * This class was generated by Apache CXF 2.1
 * Fri Jun 06 17:12:09 EDT 2008
 * Generated source version: 2.1
 * 
 */

@WebServiceClient(name = "ProtoService", targetNamespace = "urn:esbx/proto", wsdlLocation = "wsdl/PrototypeWS.wsdl")
public class ProtoService extends Service {

    public final static String SERVICE_URL_DEFAULT = "http://localhost:9441/prototypews";
    public final static String WSDL_LOCATION_DEFAULT = "wsdl/PrototypeWS.wsdl";
    public final static QName SERVICE = new QName("urn:esbx/proto", "ProtoService");
    public final static QName PrototypeWSPort = new QName("urn:esbx/proto", "PrototypeWSPort");

    protected Properties config;
    
    public ProtoService(URL wsdlLocation, QName serviceName) {
        super(wsdlLocation, serviceName);
    }

    public Server configure(Properties params) {
    	config = params;
    	System.out.println("Starting service "+SERVICE.toString());
    	String serviceURL = config.getProperty("URL", SERVICE_URL_DEFAULT);
    	System.out.println("Service endpoint URL is "+serviceURL);
    	
    	ProtoPortImpl implementor = new ProtoPortImpl(config);
    	
    	JaxWsServerFactoryBean svrFactory = new JaxWsServerFactoryBean();
    	svrFactory.setServiceClass(ProtoPort.class);
    	svrFactory.setAddress(serviceURL);
    	svrFactory.setServiceBean(implementor);
    	svrFactory.getInInterceptors().add(new LoggingInInterceptor());
    	svrFactory.getOutInterceptors().add(new LoggingOutInterceptor());
    	
    	Server svr = svrFactory.create();
    	return svr;
    }
    /**
     * 
     * @return
     *     returns ProtoPort
     */
    @WebEndpoint(name = "PrototypeWSPort")
    public ProtoPort getPrototypeWSPort() {
        return super.getPort(PrototypeWSPort, ProtoPort.class);
    }

    /**
     * 
     * @param features
     *     A list of {@link javax.xml.ws.WebServiceFeature} to configure on the proxy.  Supported features not in the <code>features</code> parameter will have their default values.
     * @return
     *     returns ProtoPort
     */
    @WebEndpoint(name = "PrototypeWSPort")
    public ProtoPort getPrototypeWSPort(WebServiceFeature... features) {
        return super.getPort(PrototypeWSPort, ProtoPort.class, features);
    }

    /**
     * Simple main to launch a standalone JAX WS Server.
     * See ProtoService javadoc for description of valid properties @see com.sonicsw.esbx.ws.ProtoService
     * @param args A single argument referencing the URI of a Properties file.
     */
	public static void main(String[] args) {

		Properties params = new Properties();
		if (args.length ==1) {
			try {
				File in = new File(args[0]);
				params.load(new FileInputStream(in));
			} catch (Exception e1) {
				System.err.println("Fatal error:  Unable to read Parameters file "+args[0]);
				e1.printStackTrace();
				System.exit(-1);
			}
		}
		else if (args.length > 1) {
			System.err.println("Usage:  java com.sonicsw.esbx.ws.ProtoService paramfile\n\t\twhere paramfile is the URI location of a valid Java Properties file.");
			System.exit(0);
		}

		// Configure Service object
		URL wsdlLocation=null;
		String wsdlLocString = params.getProperty("WSDLURL", WSDL_LOCATION_DEFAULT);
	    try {
	    	
	    	wsdlLocation = new URL(wsdlLocString);
	    } catch (MalformedURLException e) {
	        System.err.println("Can not initialize the default wsdl from "+wsdlLocString);
	    }
		// TO-DO:  pass in parameter for Service Name.
	    ProtoService service = new ProtoService(wsdlLocation, SERVICE);
	
	    Server server = service.configure(params);
	    
	    server.start();

		while(true){
			try{
				Thread.sleep(10000);
			} catch (Exception e){
				;
			}
		}
	}
}
